<template>
  <div class="row q-mb-md" v-show="error">
    <div class="col">
      <q-banner inline-actions class="text-white bg-negative">
        {{ error }}
      </q-banner>
    </div>
  </div>
  <q-form v-if="room" @submit="onSubmit">
    <div class="row q-mb-md">
      <div class="col">
        <q-input
          v-model="room.name"
          label="Name *"
          :rules="[ val => val && val.length > 0 || 'Required Field.']"
          :disable="loading"
        />
      </div>
    </div>
    <div class="row q-mb-md">
      <div class="col">
        <q-input
          v-model="room.description"
          label="Description"
          type="textarea"
          :disable="loading"
        />
      </div>
    </div>
    <div class="row q-gutter-md">
      <div class="col-1">
        <q-input
          v-model="startAtDate"
          type="date"
          label="Start Date *"
          :disable="loading"
        />
      </div>
      <div class="col-1">
        <q-input
          v-model="startAtTime"
          type="time"
          label="Time"
          :disable="loading"
        />
      </div>
    </div>
    <div class="row q-mb-md q-gutter-md">
      <div class="col-1">
        <q-input
          v-model="endAtDate"
          type="date"
          label="End Date"
          :disable="loading"
        />
      </div>
      <div class="col-1">
        <q-input
          v-model="endAtTime"
          type="time"
          label="Time"
          :disable="loading"
        />
      </div>
    </div>
    <div class="row q-ma-md">
      <div class="col q-gutter-md">
        <q-btn type="submit" label="Save" color="primary" :loading="loading" />
        <q-btn label="Cancel" :to="{ name: 'home' }" :disable="loading" />
      </div>
    </div>
  </q-form>
</template>

<script lang="ts">
import { storeToRefs } from 'pinia';
import { date } from 'quasar';
import { useRoomStore } from 'src/stores/room';
import {
  defineComponent, Ref, ref,
} from 'vue';
import { useRouter } from 'vue-router';

const now = new Date();
const roomStore = useRoomStore();
const { room } = storeToRefs(roomStore);
const { create, update } = roomStore;

export default defineComponent({
  name: 'RoomForm',
  setup() {
    const router = useRouter();
    const error: Ref<string | boolean> = ref(false);
    const loading = ref(false);
    const startAtDate = ref(date.formatDate(room.value?.start_at ?? now, 'YYYY-MM-DD'));
    const startAtTime = ref(date.formatDate(room.value?.start_at ?? now, 'HH:mm'));
    const endAtDate = ref(date.formatDate(room.value?.end_at ?? now, 'YYYY-MM-DD'));
    const endAtTime = ref(date.formatDate(room.value?.end_at ?? now, 'HH:mm'));

    function onSubmit() {
      if (room.value) {
        error.value = false;
        loading.value = true;
        room.value.start_at = new Date(`${startAtDate.value}T${startAtTime.value}${date.formatDate(now, 'Z')}`);
        room.value.end_at = new Date(`${endAtDate.value}T${endAtTime.value}${date.formatDate(now, 'Z')}`);
        room.value.access = 'CEU';
        if (room.value.id) {
          update(room.value).then(() => {
            router.push({ name: 'home' });
          }).catch((err) => {
            error.value = `Error (${err.response.status}): ${err.response.data.error}`;
          }).finally(() => {
            loading.value = false;
          });
        } else {
          create(room.value).then(() => {
            router.push({ name: 'home' });
          }).catch((err) => {
            error.value = `Error (${err.response.status}): ${err.response.data.error}`;
          }).finally(() => {
            loading.value = false;
          });
        }
      }
    }
    return {
      loading,
      error,
      startAtDate,
      startAtTime,
      endAtDate,
      endAtTime,
      room,
      onSubmit,
    };
  },
});
</script>
